      SUBROUTINE USEHORACE
c     routine for Les Houches interface to external pythir routines
c     adapted from base pythia code. 
c     M. Bellomo - C.C. Calame (july 2006)
c 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
#include "GeneratorModules/heprup.inc"
#include "GeneratorModules/hepeup.inc"
C#include "Horace_i/HERWIG65.inc"
      common/horaceinterface/alpha,anmax,iu
      double precision pw(0:3),p3(0:3),p4(0:3),qph(40,0:3),ptmp(0:3)
C      COMMON /HWHARD/ EMMIN,EMMAX
C******************************************
      DOUBLE PRECISION Q2,ALEM,ALPS
      COMMON /TRASFVAR/ Q2, ALEM, ALPS
C******************************************
C     Constants  for run 
C******************************************
      DOUBLE PRECISION SS,SQRTS
      COMMON  /SAVV/   SS,SQRTS
C********************************************************
      INTEGER ISUB
      INTEGER I
C*********************************************************
C     Counters
C**********************************************************
      INTEGER NNT1,NNT2
      DOUBLE PRECISION SIGSUM
      COMMON/COUNTER/NNT1,NNT2,SIGSUM
C********************************************************
C     save kinematics for ntuples
C
      DOUBLE PRECISION PSHAT,COSTH,X1,X2,EE1,SIGEVS,RABS
      COMMON/SAVMAN/PSHAT,COSTH,X1,X2,EE1,SIGEVS,RABS
C******************************************************
      DOUBLE PRECISION SIGWE 
      DOUBLE PRECISION PP1(4),PP2(4)
      DOUBLE PRECISION ETA1,ETA2,PTLEP
      DOUBLE PRECISION qtmp(0:3),minv
      COMMON/CUCU/ETA1,ETA2,PTLEP
C
C-----------------------------------------------------------------
C...Default return value.
      XWGTUP=0D0
**********
      read(iu,*) ! reads '------------------'


      read(iu,*)nnt1
      read(iu,*)nphot
      read(iu,*)x1,x2,SCALUP
      read(iu,*)idup(1),idup(2)
      idup(3) = 0  ! see hep-ph/0109068 -- intermediate particles have idup = 0
      read(iu,*)idup(4),idup(5)

cc cosi' sistemiamo la nonna...
C      idup(3) = -idup(4)/abs(idup(4))*24

      AQEDUP = alpha      ! alpha for QED radiation from HORACE
      AQCDUP = ALPS
C
      read(iu,*)XWGTUP
      read(iu,*)p3
      read(iu,*)p4
      if (nphot.gt.0) then
         do k = 1,nphot
            idup(5+k) = 22 
            read(iu,*)qph(k,0),qph(k,1),qph(k,2),qph(k,3) 
         enddo
      endif
      ipart1 = idup(1)
      ipart2 = idup(2)

      NUP = 5 + nphot

      qtmp(0) = p3(0) + p4(0) 
      qtmp(1) = p3(1) + p4(1)
      qtmp(2) = p3(2) + p4(2) 
      qtmp(3) = p3(3) + p4(3) 
      
******

      NNT2=NNT2+1

*  sum of photons' momenta (ptmp)
      do k = 0,3
         ptmp(k) = 0.d0
      enddo
      if (nphot.gt.0) then
         do k = 1,nphot
            do i = 0,3
               ptmp(i) = ptmp(i) + qph(k,i)
            enddo
         enddo
      endif
      
			!WRITE(6,*) 'USEHORACE --> HORACE execution d'

*********
*********************
      PSHAT=X1*X2*SS
C			write(6,*)'X1',X1,' X2',X2,' SS',SS,' sdif',sdif
C

      SIGSUM = SIGSUM+XWGTUP

C**************************************
C     particles momenta:
C**********************
      PP1(1)=0
      PP1(2)=0
      PP1(3)=X1*SQRTS/2.D0
      PP1(4)=PP1(3)
      PP2(1)=0
      PP2(2)=0
      PP2(3)=-X2*SQRTS/2.D0
      PP2(4)=-PP2(3)

! W momentum
      do k = 0,3
         pw(k) = p3(k) + p4(k) + ptmp(k)
      enddo
C
C     fill pythia common
C
C...Store scale choice etc.

C...Status codes.
      ISTUP(1)=-1
      ISTUP(2)=-1
      ISTUP(3)= 2 ! intermeditate time-like W
      ISTUP(4)= 1
      ISTUP(5)= 1
      if (nphot.gt.0) then
         do k = 1,nphot
            istup(5+k) = 1
         enddo
      endif

C...Mother codes.
      MOTHUP(1,1) = 0
      MOTHUP(2,1) = 0
      MOTHUP(1,2) = 0
      MOTHUP(2,2) = 0
      MOTHUP(1,3) = 1
      MOTHUP(2,3) = 2
      MOTHUP(1,4) = 3
      MOTHUP(2,4) = 3
      MOTHUP(1,5) = 3
      MOTHUP(2,5) = 3

      if (nphot.gt.0) then
         do k = 1,nphot
            MOTHUP(1,5+k) = 3
            MOTHUP(2,5+k) = 3
         enddo
      endif
C

* COLOR FLOW for HORACE
      if (ipart1.gt.0) then 
         icolup(1,1) = 501
         icolup(2,1) = 0
      else
         icolup(1,1) = 0
         icolup(2,1) = 501
      endif
      if (ipart2.gt.0) then 
         icolup(1,2) = 501
         icolup(2,2) = 0
      else
         icolup(1,2) = 0
         icolup(2,2) = 501
      endif
*************
      DO I=1,4
        ihor = i
        if (i.eq.4) ihor = 0
        PUP(I,1) = PP1(I)
        PUP(I,2) = PP2(I)
        pup(i,3) = pw(ihor)
        pup(i,4) = p3(ihor)
        pup(i,5) = p4(ihor)
        if (nphot.gt.0) then
           do k = 1,nphot
              pup(i,5+k) = qph(k,ihor)
           enddo
        endif
      ENDDO

      PUP(5,3) = sqrt(pw(0)**2 - pw(1)**2 - pw(2)**2 - pw(3)**2)
      PUP(5,4) = sqrt(p3(0)**2 - p3(1)**2 - p3(2)**2 - p3(3)**2)
      pup(5,5) = 0.d0

      if (nphot.gt.0) then
         do k = 1,nphot
            pup(5,5+k) = 0.d0
         enddo
      endif			
      RETURN
      END
